import React from 'react';
import styled, { ThemeProvider } from 'styled-components';
import Masonry from 'react-masonry-css';
import { createTheme } from '../../theme';
import { Widget } from './Widget';
import { WidgetContextProvider } from './context';
var Wrapper = styled(Masonry)({
    display: 'flex',
    width: '100%',
    margin: '1em 0',
    '.masonryColumn': {
        margin: '0 1em',
        height: '100%',
    },
});
var breakpointColumns = {
    default: 2,
    760: 1,
};
export var Dashboard = function (props) {
    var client = props.client, provider = props.provider, config = props.config;
    return (React.createElement(ThemeProvider, { theme: createTheme(config.theme) },
        React.createElement(Wrapper, { breakpointCols: breakpointColumns, columnClassName: "masonryColumn", className: "masonryGrid" }, Object.entries(config.widgets || []).map(function (_a) {
            var widgetConfigKey = _a[0], widgetConfig = _a[1];
            return (React.createElement(WidgetContextProvider, { key: widgetConfigKey, client: client, provider: provider, config: widgetConfig },
                React.createElement(Widget, { as: widgetConfig.as })));
        }))));
};
