var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { useEffect, useState } from 'react';
import { Box } from '../../../elements';
import { useWidgetContext } from '../../context';
import { StatisticBox, StatisticsContainer, GoToLink, WidgetTitle, Header, LoaderWrapper, } from './styles';
import { StatisticColumn } from './StatisticColumn';
import { automatedTasks, automationRate, initialStatisticData, knowledgePool, statisticWidgetData, } from './mockData';
export var Statistic = function () {
    var _a = useWidgetContext(), client = _a.client, title = _a.config.title;
    var placeholder = 'Empty';
    var _b = useState(statisticWidgetData), data = _b[0], setData = _b[1];
    useEffect(function () {
        var fetchData = function () { return __awaiter(void 0, void 0, void 0, function () {
            var automationRateData, automatedTaskData, knowledgePoolData, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        setData({ result: initialStatisticData, loading: true, error: false });
                        return [4 /*yield*/, Promise.resolve(automationRate)];
                    case 1:
                        automationRateData = _a.sent();
                        return [4 /*yield*/, Promise.resolve(automatedTasks)];
                    case 2:
                        automatedTaskData = _a.sent();
                        return [4 /*yield*/, Promise.resolve(knowledgePool)];
                    case 3:
                        knowledgePoolData = _a.sent();
                        setData({
                            loading: false,
                            error: false,
                            result: [automationRateData, automatedTaskData, knowledgePoolData],
                        });
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        setData({ result: [], error: true, loading: false });
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        fetchData();
    }, []);
    if (!data.loading && (!data.result || data.result.length === 0)) {
        return (React.createElement(Box, { centered: true, verticalAlign: "center" },
            React.createElement("span", null, placeholder)));
    }
    if (data.error) {
        return (React.createElement(Box, { centered: true, verticalAlign: "center" },
            React.createElement("span", null, "Fetching Error")));
    }
    return (React.createElement(StatisticBox, null,
        React.createElement(Header, null,
            React.createElement(WidgetTitle, null, title),
            React.createElement(GoToLink, null, "Go to HIRO Portal")),
        React.createElement(StatisticsContainer, null,
            data.result.map(function (_a) {
                var title = _a.title, differenceText = _a.differenceText, whatItIs = _a.whatItIs, howToImprove = _a.howToImprove, angle = _a.angle, valueText = _a.valueText, valueColor = _a.valueColor, backgroundColor = _a.backgroundColor;
                return (React.createElement(StatisticColumn, { title: title, whatItIs: whatItIs, howToImprove: howToImprove, differenceText: differenceText, angle: angle, valueText: valueText, valueColor: valueColor, backgroundColor: backgroundColor, key: title }));
            }),
            data.loading && React.createElement(LoaderWrapper, null))));
};
export default Statistic;
