import React from 'react';
import { DiffText, InfoBody, InfoIcon, StatisticsColumn, TitleText, } from './styles';
import { Popover } from '../../../elements/Popover';
import { ProgressIndicator } from '../../../elements/ProgressIndicator';
export var StatisticColumn = function (_a) {
    var title = _a.title, whatItIs = _a.whatItIs, howToImprove = _a.howToImprove, differenceText = _a.differenceText, angle = _a.angle, valueText = _a.valueText, valueColor = _a.valueColor, backgroundColor = _a.backgroundColor;
    var _b = React.useState(null), popoverAnchor = _b[0], setPopoverAnchor = _b[1];
    var popoverOpen = Boolean(popoverAnchor);
    var openPopover = function (event) {
        setPopoverAnchor(event.currentTarget);
    };
    var closePopover = function () {
        setPopoverAnchor(null);
    };
    return (React.createElement(StatisticsColumn, null,
        React.createElement(TitleText, null,
            title,
            React.createElement(InfoIcon, { onMouseOver: openPopover, onMouseLeave: closePopover }),
            React.createElement(Popover, { isOpen: popoverOpen, anchorElement: popoverAnchor, placing: "top" },
                React.createElement(InfoBody, null,
                    React.createElement("strong", null, "What it is:"),
                    React.createElement("p", null, whatItIs),
                    React.createElement("strong", null, "How to improve:"),
                    React.createElement("p", null, howToImprove)))),
        React.createElement(ProgressIndicator, { valueText: valueText, valueColor: valueColor, backgroundColor: backgroundColor, angle: angle }),
        React.createElement(DiffText, null, differenceText)));
};
