var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import styled from 'styled-components';
import { InfoCircle } from 'styled-icons/fa-solid';
import { Button } from '../../../inputs/Button';
import { Box } from '../../../elements/Flex';
import defaultTheme from '../../../../theme';
import { Loader } from '../../../modules/Loader';
export var Header = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 100%;\n  display: flex;\n  justify-content: space-between;\n  flex-wrap: wrap;\n  align-items: center;\n"], ["\n  width: 100%;\n  display: flex;\n  justify-content: space-between;\n  flex-wrap: wrap;\n  align-items: center;\n"])));
export var WidgetTitle = styled.span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  font-size: 18px;\n  font-weight: bold;\n  line-height: 35px;\n  color: #393941;\n"], ["\n  font-size: 18px;\n  font-weight: bold;\n  line-height: 35px;\n  color: #393941;\n"])));
export var TitleText = styled.span(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  color: #519375;\n  font-size: 16px;\n  width: 100%;\n  text-align: center;\n  padding-top: 20px;\n  padding-bottom: 20px;\n"], ["\n  color: #519375;\n  font-size: 16px;\n  width: 100%;\n  text-align: center;\n  padding-top: 20px;\n  padding-bottom: 20px;\n"])));
export var StatisticsContainer = styled.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n  justify-content: space-around;\n  flex-wrap: wrap;\n  width: 100%;\n  padding-bottom: 40px;\n"], ["\n  display: flex;\n  flex-direction: row;\n  justify-content: space-around;\n  flex-wrap: wrap;\n  width: 100%;\n  padding-bottom: 40px;\n"])));
export var StatisticsColumn = styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  width: 33.3%;\n  min-width: 180px;\n"], ["\n  display: flex;\n  flex-direction: column;\n  width: 33.3%;\n  min-width: 180px;\n"])));
export var DiffText = styled.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  color: #afafaf;\n  font-size: 14px;\n  width: 100%;\n  text-align: center;\n  padding-top: 20px;\n"], ["\n  color: #afafaf;\n  font-size: 14px;\n  width: 100%;\n  text-align: center;\n  padding-top: 20px;\n"])));
export var InfoIcon = styled(InfoCircle).attrs({
    color: '#519375',
})({
    paddingBottom: '6px',
    paddingLeft: '4px',
    width: '14px',
});
export var InfoBody = styled.div({
    fontSize: 10,
    maxWidth: 220,
    textAlign: 'left',
});
export var GoToLink = styled(Button).attrs({
    as: 'a',
    href: 'https://hiro.arago.co/',
    target: '_blank noopener noreferer',
    secondary: true,
    color: 'green',
})({
    textDecoration: 'none',
    '&:hover, &:focus': {
        color: '#1DA75D',
    },
});
export var StatisticBox = styled(Box).attrs({
    centered: true,
    verticalAlign: 'center',
})(function (_a) {
    var theme = _a.theme;
    return ({
        borderRadius: theme.sizes.borderRadius,
        flexWrap: 'nowrap',
    });
});
var LoaderWrapperComponent = styled.div({
    width: '100%',
    height: '100%',
    background: '#fff',
    position: 'absolute',
    top: 0,
    left: 0,
});
export var LoaderWrapper = function () { return (React.createElement(LoaderWrapperComponent, null,
    React.createElement(Loader, { active: true }))); };
StatisticBox.defaultProps = {
    theme: defaultTheme,
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
