import React from 'react';
import { useWidgetContext } from '../../context';
import { Box } from '../../../elements';
import { topContributors, MockAvatar } from '../../../mockData';
import { AvatarWrapper, Column, ContributorContainer, ContributorEmail, ContributorInfo, ContributorSessions, ContributorRanking, GoToBtn, WidgetTitle, Header, Body, } from './styles';
var ContributorAvatar = function (_a) {
    var userId = _a.userId, ranking = _a.ranking, graphUrl = _a.graphUrl;
    return (React.createElement(AvatarWrapper, null,
        React.createElement(ContributorRanking, null, ranking),
        React.createElement(MockAvatar, null)));
};
var Contributor = function (_a) {
    var userId = _a.userId, ranking = _a.ranking, count = _a.count;
    return (React.createElement(ContributorContainer, null,
        React.createElement(ContributorAvatar, { ranking: ranking, userId: userId }),
        React.createElement(ContributorInfo, null,
            React.createElement(ContributorEmail, null, userId),
            React.createElement(ContributorSessions, null,
                React.createElement("b", null, count),
                " Completed Teaching Sessions"))));
};
var columns = 2;
var totalCount = Object.keys(topContributors).length;
var maxPerColumn = Math.ceil(totalCount / columns);
export var TopContributors = function () {
    var _a = useWidgetContext(), client = _a.client, _b = _a.provider, selectMe = _b.selectMe, getEnvUrls = _b.getEnvUrls, openApp = _b.openApp, title = _a.config.title;
    // TODO: Get GraphUrl from combined selector from Desktop when real data comes in
    var graphUrl = '';
    var aragoIdUrl = getEnvUrls().aragoIdUrl;
    // TODO: fetch info from Dashboard.TopContributors timeseries vertex
    // TODO: fetch emails for each userId
    var contributorsColumns = React.useMemo(function () { return getColumns(topContributors); }, [
        topContributors,
    ]);
    return (React.createElement(Box, { centered: true },
        React.createElement(Header, null,
            React.createElement(WidgetTitle, null, title),
            React.createElement(GoToBtn, { aragoIdUrl: aragoIdUrl }, "Go to Arago ID")),
        React.createElement(Body, null, contributorsColumns.map(function (rows, columnIndex) { return (React.createElement(Column, { key: columnIndex }, rows.map(function (_a) {
            var userId = _a.userId, ranking = _a.ranking, count = _a.count;
            return (React.createElement(Contributor, { key: userId, userId: userId, ranking: ranking, count: count }));
        }))); }))));
};
var getColumns = function (topContributors) {
    var columnIndex = 0;
    return Object.entries(topContributors).reduce(function (columns, stats, i) {
        var contributor = {
            userId: stats[0],
            count: stats[1],
            ranking: i + 1,
        };
        if (columns[columnIndex].length >= maxPerColumn) {
            columnIndex += 1;
            columns.push([contributor]);
            return columns;
        }
        columns[columnIndex].push(contributor);
        return columns;
    }, [[]]);
};
