var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useCallback, useState } from 'react';
import styled from 'styled-components';
import { Check } from 'styled-icons/fa-solid/Check';
import defaultTheme from '../../../theme';
/**
 * Hidden checkbox
 */
var HiddenCheckbox = styled.input.attrs({ type: 'checkbox' })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  // Hide checkbox visually but remain accessible to screen readers.\n  // Source: https://polished.js.org/docs/#hidevisually\n  border: 0;\n  clip: rect(0 0 0 0);\n  clippath: inset(50%);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  white-space: nowrap;\n  width: 1px;\n"], ["\n  // Hide checkbox visually but remain accessible to screen readers.\n  // Source: https://polished.js.org/docs/#hidevisually\n  border: 0;\n  clip: rect(0 0 0 0);\n  clippath: inset(50%);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  white-space: nowrap;\n  width: 1px;\n"])));
var CustomCheckbox = styled.div({
    width: '20px',
    height: '20px',
    display: 'inline-block',
    position: 'relative',
    borderRadius: '5px',
}, 
// Themed
function (_a) {
    var theme = _a.theme;
    return ({
        border: "1px solid " + theme.greyscale.medium,
    });
}, 
// Add margin for label
function (_a) {
    var hasLabel = _a.hasLabel;
    return hasLabel
        ? {
            marginRight: '0.5em',
        }
        : null;
});
CustomCheckbox.defaultProps = {
    theme: defaultTheme,
};
/**
 * Checkbox styled components
 */
var StyledLabel = styled.label({
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'start',
    cursor: 'pointer',
}, 
// States
function (_a) {
    var _b, _c;
    var theme = _a.theme;
    return ({
        '&:focus, &:focus:hover, &:hover': (_b = {},
            _b[CustomCheckbox] = {
                borderColor: theme.colors.primary.default,
            },
            _b),
        '&:hover': (_c = {},
            _c[CustomCheckbox] = {
                boxShadow: "1px 1px 12px 0 " + theme.greyscale.dark,
            },
            _c),
    });
});
StyledLabel.defaultProps = {
    theme: defaultTheme,
};
var StyledDiv = styled.div({
    display: 'inline-block',
    alignSelf: 'flex-start',
});
/**
 * Check icon
 */
var StyledCheck = styled(Check)(function (_a) {
    var theme = _a.theme;
    return ({
        color: theme.colors.primaryText.default,
        transition: 'all .2s',
        position: 'absolute',
        top: '2px',
        left: '2px',
    });
});
StyledCheck.defaultProps = {
    theme: defaultTheme,
};
/**
 * Checkbox input
 */
export var Checkbox = function (_a) {
    var children = _a.children, checked = _a.checked, onChange = _a.onChange, rest = __rest(_a, ["children", "checked", "onChange"]);
    var isControlled = checked !== undefined;
    var _b = useState(false), currentValue = _b[0], setCurrentValue = _b[1];
    var usedValue = isControlled ? checked : currentValue;
    var handleChange = useCallback(function (e) {
        if (!isControlled) {
            setCurrentValue(e.target.checked);
            return;
        }
        if (onChange) {
            onChange(e);
        }
    }, [onChange, isControlled]);
    return (React.createElement(StyledDiv, null,
        React.createElement(StyledLabel, null,
            React.createElement(CustomCheckbox, { hasLabel: !!children }, usedValue && React.createElement(StyledCheck, { width: 14, height: 14 })),
            React.createElement(HiddenCheckbox, __assign({}, rest, { checked: usedValue, onChange: handleChange })),
            children)));
};
var templateObject_1;
