import React from 'react';
import Client from '@hiro-graph/client';
export var smeConfig = {
    theme: {
        colors: {
            green: '#519375',
        },
        sizes: {
            borderRadius: '0.75em',
            padding: {
                normal: '1rem',
            },
        },
    },
    widgets: {
        SessionList: {
            as: 'SessionList',
            title: 'Your recent Sessions',
            size: '100%',
        },
        Welcome: {
            as: 'Welcome',
            title: 'Welcome',
        },
        TopContributors: {
            as: 'TopContributors',
            title: 'Top Knowledge Contributors',
        },
        Statistic: {
            as: 'Statistic',
            title: 'Your HIRO Statistics',
        },
    },
};
export var me = {
    displayName: 'John Doe',
    id: 'uiouweqjkqehjkq',
    accountId: 'cjzmpitln02iz1d067qouut2r',
    email: 'johndoe@gmail.com',
    roles: ['SME'],
};
export var envUrls = {
    graphUrl: '',
    aragoIdUrl: '',
};
export var appIds = {
    katId: 'cjk15cvij001aw434rx6ia8vs',
    atqId: 'ck1t7k4es0y1zm362u6t6d2wo',
    ivId: 'ck1t6lkuv0xxcm362hr8pddw0',
    kimId: 'ck1t754a40y06m362h1yw1plo',
};
// in real data we will have userIds instead of emails
export var topContributors = {
    'e2e@arago.co': 114,
    'anton@arago.co': 99,
    'sme@arago.co': 62,
    'vit@arago.co': 55,
    'ssabina@arago.co': 37,
    'ilya@arago.co': 21,
};
export var MockAvatar = function () { return (React.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 150 150", style: {
        height: '59px',
        width: '59px',
        position: 'absolute',
        left: '-3px',
        top: '-3px',
    } },
    React.createElement("path", { fill: "#cdcdcd", d: "M 75,5 A 70,70 0 0 0 5,75 70,70 0 0 0 75,145 70,70 0 0 0 145,75 70,70 0 0 0 75,5 Z m 43.456058,72.434887 c 0.27988,-0.0043 0.56543,0.01911 0.8516,0.07114 2.28937,0.416248 3.74583,2.706426 3.22552,4.99579 -4.68279,22.581463 -24.767172,38.917563 -47.764879,38.917563 -22.581458,0 -42.145117,-15.40117 -47.348218,-37.462321 -0.52031,-2.289364 0.832496,-4.577102 3.12186,-5.097412 2.289365,-0.52031 4.579135,0.832496 5.099445,3.12186 4.370605,18.210853 20.501437,30.905603 39.232601,30.905603 19.043349,0 35.587591,-13.528465 39.437881,-32.155566 0.45528,-1.91214 2.1851,-3.266776 4.14419,-3.296653 z" }))); };
export var provider = {
    openApp: function () { return undefined; },
    selectMe: function () { return me; },
    selectAppsIds: function () { return appIds; },
    getEnvUrls: function () { return envUrls; },
};
export var createClient = function (mocks) {
    var client = new Client({
        endpoint: '',
        token: '',
    }, {
        forceHTTP: true,
    });
    Object.entries(mocks).forEach(function (_a) {
        var key = _a[0], value = _a[1];
        // @ts-ignore
        client[key] = value;
    });
    return client;
};
